#!/usr/bin/perl

  require './apache-lib.pl';
  &ReadParse();


  $access{'create'} || &error($text{'cvirt_ecannot'});
  &error_setup($text{'cvirt_err'});


  ### Setup IP Address.
  if (&check_ipaddress($in{'addr'})) { $addr = $in{'addr'}; }
  else { &PrintError("'$in{'addr'}' is not a valid IP address."); exit; }


  ### Setup Port.
  ### $port = ":$in{'port'}";
  if (!$in{'port'}) { $port = ":80";  $in{'port'} = 80; }
  else              { $port = ":443"; $in{'port'} = 443; }

  ### Setup ServerAdmin.
  if ($in{'admin'} =~ m/^.*@.*$/) { $admin = $in{'admin'}; }
  else { &PrintError("'$in{'admin'}' is not a valid admin e-mail."); exit; }

  ### Setup ServerName.
  if ($in{'name'} =~ m/^[A-Za-z0-9\-\.]+$/) { $name = $in{'name'}; }
  else { &PrintError("'$in{'name'}' is not a valid hostname."); exit; }

  ### Setup Webmaster.
  if ($in{'webmaster'} =~ m/^[A-Za-z0-9\.]{1,16}$/) {
    $webmaster = $in{'webmaster'};
  }
  else { &PrintError("'$in{'webmaster'}' is not a valid user."); exit; }

  ### Setup Group.
  if ($in{'group'} =~ m/^[A-Za-z][A-Za-z0-9\.]{1,15}$/) {
    $group = $in{'group'};
  }
  else { &PrintError("'$in{'group'}' is not a valid group name."); exit; }



  ### This is the base directory for this virtual host.
  ### If our base directory exists let's flag off an error.
  $root = "/home/httpd/$name-$in{'port'}";
  if (-d $root) { &error("$root exists."); }

  ### ############################# ###
  ### We wish to create a database. ###
  ### ############################# ###
  if ($in{'create_db'}) {
 
    if ($in{'port'} == 443) {
      &PrintError("You can not currently create a database for an SSL site.");
      exit;
    }
 
    ### Check integrity of username. 
    if ($in{'db_uname'} =~ m/^[A-Za-z0-9]{1,16}$/) {
      $db_uname = $in{'db_uname'};
    }
    else {
      &PrintError("'$in{'db_uname'}' is not a valid database username.");
      exit;
    }

    ### Check integrity of password. 
    if ($in{'db_pass'} =~ m/^[^\'\"\/]{1,16}$/) {
      $db_pass = $in{'db_pass'};
    }
    else {
     $in{'db_pass'} =~ s/\"/\\\"/g;
     &PrintError("'$in{'db_pass'}' is not a valid database password.");
     exit;
    }


    ### Make the database name.
    $db_name = $in{'name'}; $db_name =~ s/\./\_/g;

    ### Let's use the DBI since it's SO much more fun...
    use DBI;

    ### Get root's mysql password.
    open FILE, "/etc/webtool/SystemManager/config";
      while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $mysql_pass = $1; } }
    close FILE;

    ### Setup DBMS variables.
    $database = "mysql"; $host = "localhost"; $user = "root";


    ### Connect to the database.
    my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host", "$user",
                           "$mysql_pass");


    ### Create the database.
    $sth = $dbh->prepare("CREATE DATABASE $db_name");
    $sth->execute();
    $sth->finish();


    ### Create the user.
    $sth = $dbh->prepare("INSERT INTO mysql.user VALUES ('localhost',
                         '$db_uname', PASSWORD('$db_pass'), 'N', 'N', 'N', 'N',
                         'N', 'N', 'N', 'N', 'N', 'N', 'N', 'N', 'N', 'N')");
    $sth->execute();
    $sth->finish();


    ### Create the database permissions.
    $sth = $dbh->prepare("INSERT INTO mysql.db VALUES ('localhost', '$db_name',
                         '$db_uname', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y',
                         'Y', 'Y')");
    $sth->execute();
    $sth->finish();


    ### Reload the grant tables.
    $sth = $dbh->prepare("FLUSH PRIVILEGES");
    $sth->execute();
    $sth->finish();


    ### Disconnect from the DBMS.
    $dbh->disconnect();
  }

  ### Create all the directories that we need.
  system("/bin/mkdir --mode=0775 -p $root/cgi-bin > /dev/null 2>&1");
  system("/bin/mkdir --mode=0775 -p $root/html > /dev/null 2>&1");
  system("/bin/mkdir --mode=0755 -p $root/logs > /dev/null 2>&1");

  if ($in{'port'} == 443) {
    system("/bin/mkdir --mode=0750 -p $root/ssl > /dev/null 2>&1");
  }


  ### Find file to add to.
  $f = $config{'virt_file'};
  if (!$f) {
    ### Use the first file in config (usually httpd.conf).
    $vconf = &get_virtual_config();
    $f = $vconf->[0]->{'file'};
    for($j=0; $vconf->[$j]->{'file'} eq $f; $j++) { }
    $l = $vconf->[$j-1]->{'eline'}+1;
  }


  ### Read the lines, push onto the end, then flush them back out.
  $lref = &read_file_lines($f);
    push(@$lref, "");
    push(@$lref, "<VirtualHost $addr$port>");
    push(@$lref, "<Directory \"$root/html\">");
    push(@$lref, "  AllowOverride all");
    push(@$lref, "</Directory>");
    push(@$lref, "");
    push(@$lref, "<Directory \"$root/cgi-bin\">");
    push(@$lref, "  Options +ExecCGI");
    push(@$lref, "</Directory>");
    push(@$lref, "");
    push(@$lref, "DocumentRoot $root/html");
    push(@$lref, "ServerName $name");
    push(@$lref, "ServerAdmin $admin");
    push(@$lref, "ScriptAlias /cgi-bin/ $root/cgi-bin/");
    push(@$lref, "ErrorLog $root/logs/error_log");
    push(@$lref, "TransferLog $root/logs/access_log");

    if ($port eq ":443") {
      push(@$lref, "\nSSLEngine off");
      push(@$lref, "SSLLog $root/logs/ssl_engine_log");
    }

    push(@$lref, "</VirtualHost>");
    push(@$lref, "");
  &flush_file_lines();


  ### If it's not an SSL server, write a webalizer configuration.
  if ($port ne ":443") {
    ### Setup the WEBSTATS directory.
    system("/bin/mkdir --mode=0775 -p $root/html/WEBSTATS > /dev/null 2>&1");
    system "/bin/chmod 2751 $root/html/WEBSTATS > /dev/null 2>&1;";

    ### Create a Webalizer configuration file.
    if (!-r "/etc/webalizer") { mkdir "/etc/webalizer", 0755; }

    open WEBSTATS, ">/etc/webalizer/$name.conf";
      print WEBSTATS "LogFile\t$root/logs/access_log\n";
      print WEBSTATS "OutputDir\t$root/html/WEBSTATS\n";
      print WEBSTATS "HostName\t$name\n\n";
  
      print WEBSTATS "LogType\tweb\n";
    close WEBSTATS;

    ### Create a Webalizer .htacess and .htpasswd.
    system "/bin/touch $root/html/WEBSTATS/.htpasswd";
    open HTACCESS, ">$root/html/WEBSTATS/.htaccess";
      print HTACCESS "AuthUserFile $root/html/WEBSTATS/.htpasswd\n";
      print HTACCESS "AuthName \"Web Stats for $name\"\n";
      print HTACCESS "AuthType Basic\n\n";

      print HTACCESS "<Limit GET>\n";
      print HTACCESS "require valid-user\n";
      print HTACCESS "</Limit>\n\n";
    close HTACCESS;
  }


  ### Recursively set the user to our "Webmaster".
  system "/bin/chown -R $webmaster.$group $root/cgi-bin > /dev/null 2>&1";
  system "/bin/chown -R $webmaster.$group $root/html > /dev/null 2>&1";
  system "/bin/chown -R root.$group $root/logs > /dev/null 2>&1";

  system "/bin/chmod 2755 $root/cgi-bin > /dev/null 2>&1;";
  system "/bin/chmod 2755 $root/html > /dev/null 2>&1;";
  system "/bin/chmod 2775 $root/logs > /dev/null 2>&1;";

  if ($port eq ":443") {
    system "/bin/chown -R $webmaster.$group $root/ssl > /dev/null 2>&1";
    system "/bin/chmod 2750 $root/ssl > /dev/null 2>&1";
  }


  ### Restart the daemon.
  system("/etc/init.d/httpd restart > /dev/null 2>&1");

  ### Go back to index page.
  &redirect("");

