#!/usr/bin/perl

  require "apache-lib.pl";
  require "../guardiandigital-lib.pl";
  &ReadParse();

#  print "Content-type: text/html\n\n<PRE>\n\n";
#  foreach (sort keys %in) {
#    print "$_ = $in{$_}\n";
#  }
#  exit;

  $openssl = "/usr/bin/openssl";

  if (!$in{'countryName'}) { &PrintError("Please enter a Country Name"); }
  elsif (!$in{'stateOrProvinceName'}) {
    &PrintError("Please enter a State or Provence");
  }
  elsif (!$in{'localityName'}) {
    &PrintError("Please enter a City");
  }
  elsif (!$in{'organizationName'}) {
    &PrintError("Please enter an Organization");
  }
  elsif (!$in{'commonName'}) {
    &PrintError("Please enter an Authority Name");
  }
  elsif (!$in{'emailAddress'}) {
    &PrintError("Please enter an E-Mail Address");
  }


  ### We want to generate a cert and key, along with making our CSR.
  if ($in{'new'}) {

    ### Setup our destinations.
    my $server_cert = "$in{'ssldir'}/certificate.pem";
    my $server_key  = "$in{'ssldir'}/key.pem";


    ### Setup temporary files.
    my $cert_temp = &tempname(); 
    my $key_temp = &tempname(); 


    ### Open a pipe to ssl and give it our info, and output the cert and key.
    open CA, "| $openssl req -new -x509 -days 365 -nodes -out $cert_temp -keyout $key_temp -config /etc/ssl/openssl.cnf > /dev/null 2>&1";
      print CA "$in{'countryName'}\n";
      print CA "$in{'stateOrProvinceName'}\n";
      print CA "$in{'localityName'}\n";
      print CA "$in{'organizationName'}\n";
      print CA "$in{'organizationalUnitName'}\n";
      print CA "$in{'commonName'}\n";
      print CA "$in{'emailAddress'}\n";
    close CA;


    ### If they exist, move the two files into place.
    if (-r $cert_temp && -r $key_temp) {
      system "mv -f $cert_temp $server_cert";
      system "mv -f $key_temp $server_key";
      system "chmod 400 $server_cert";
      system "chmod 400 $server_key";
    }

    ### We're all done so let's remove our temporary files.
    unlink $cert_temp, $key_temp;

    ### Save the directives with our new certificates. ###

    ### Get our config.
    $conf = &get_config();
    $vconf = $conf->[$in{'virt'}];

      ### Read our file lines in.
      $lref = &read_file_lines($vconf->{'file'});

      ### Turn on SSL.
      &save_directive("SSLEngine", [ "on" ], $vconf->{'members'}, $conf);

      ### Update the SSLCertificateFile directive.
      &save_directive("SSLCertificateFile", [ $server_cert ],
                      $vconf->{'members'}, $conf);

      ### Update the SSLCertificateKeyFile directive.
      &save_directive("SSLCertificateKeyFile", [ $server_key ],
                      $vconf->{'members'}, $conf);

  ### Write the file back to disk.
  &flush_file_lines();
  }

  ### ##########################################################################
  ### Okay, now lets do the CSR. ###############################################
  ### ##########################################################################

    ### Setup temp file.
    my $csr_temp = &tempname(); 

    ### Run openssl to generate it.
    open CSR, "| $openssl req -new -key $in{'ssldir'}/key.pem -out $csr_temp > /dev/null 2>&1";
      print CSR "$in{'countryName'}\n";
      print CSR "$in{'stateOrProvinceName'}\n";
      print CSR "$in{'localityName'}\n";
      print CSR "$in{'organizationName'}\n";
      print CSR "$in{'organizationalUnitName'}\n";
      print CSR "$in{'commonName'}\n";
      print CSR "$in{'emailAddress'}\n";
      print CSR "\n\n";
    close CSR;

    ### Read the CSR into $csr for displaying to user.
    open CSR, $csr_temp; while (<CSR>) { $csr .= $_; } close CSR;

    ### Delete the file.
    #unlink $csr_temp;


  ### Redirect back to the server's index page.
  &redirect("display_csr.cgi?virt=$in{'virt'}&csr_file=$csr_temp");

