#!/usr/bin/perl

  require './apache-lib.pl';

  ### Check for the httpd.conf file.
  if ($config{'httpd_conf'}) { $htconf = $config{'httpd_conf'}; }
  else { $htconf = "$conf/httpd.conf"; }

  if (!-r $htconf) {
    ### Still doesn't exist!
    &header("Virtual Host Management", "");

    print "<CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>\n";
    print "<TR><TD>\n";
    print &text('index_econf', "<tt>$htconf</tt>",
          "/config.cgi?$module_name"),"<p>\n";

    print "</TD></TR>\n";
    print "</TABLE></CENTER>\n\n";

    &ryanFooter("/");
    exit;
  }


  ### Extract the configuration file into $conf.
  $conf = &get_config();

  ### ####################################### ###
  ### Print the header and let the fun begin. ###
  ### ####################################### ###
  &header("Virtual Host Management", "");


  ### Add all of the servers.
  @virt = &find_directive_struct("VirtualHost", $conf);

print <<EOF01;
<P><CENTER><TABLE WIDTH=620 BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR $tb><TD COLSPAN=3><DIV CLASS=ttitle><B>Virtual Servers</TD></TR>

  <TR $cb>
    <TD COLSPAN=3><DIV CLASS=nbody>
      Below is a listing of the virtual servers you currently have on your
      system.
   </DIV></TD>
  </TR>

  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>

  <TR $tb>
    <TD><DIV CLASS="thead"><b>$text{'index_port'}</b></TD>
    <TD><DIV CLASS="thead"><b>$text{'index_name'}</b></TD>
    <TD><DIV CLASS="thead"><b>$text{'index_root'}</b></TD>
  </TR>

EOF01



  foreach $v (@virt) {
    $INDEX = &indexof($v, @$conf);
    $vconf = &get_config()->[$INDEX];

    ### Extract DocumentRoot directive.
    $tmp = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $ROOT = $tmp->{'words'}->[0];

    ### Extract ServerName directive.
    $tmp = &find_directive_struct("ServerName", $vconf->{'members'});
    $NAME = $tmp->{'words'}->[0];

    ### Extract DocumentRoot directive.
    $tmp = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $DROOT = $tmp->{'words'}->[0];

    ### Extract Port directive.
    if ($v->{'value'} =~ /^(\S+):(\S+)$/) { $PORT = $2; }
    else { $PORT = &def(&find_directive("Port", $conf), 80); }

    if ((! -e "$DROOT/conf/site.pm") && ($INDEX != "-1")){
      print "  <TR $cb>\n";
      print "    <TD><DIV CLASS=nbody>$PORT</TD>\n";
      print "    <TD><DIV CLASS=nbody>\n";
      print "      <A HREF=\"virt_index.cgi?virt=$INDEX\">$NAME</A>\n";
      print "    </TD>\n";
      print "    <TD WIDTH=60%><DIV CLASS=nbody>$DROOT</TD>\n";
      print "  </TR>\n";
    }

  }

  print "  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>\n";
  print "</TABLE></CENTER>\n";

print <<EOF;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>
      Virtual Host Management
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      Below you can configure your virtual hosts.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="vhost_create.cgi">Create a Virtual Host</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Setup a new virtual host.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="vhost_create_ssl.cgi">Create an SSL Virtual Host</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Setup a new SSL-based virtual host.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>
  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="nv_hosts.cgi">Setup Name Virtual Hosts</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>
      Configure which IP addresses you would like to run virtual hosts from.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="webalizer/">Configure Website Log Analysis</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>
      Configure various options for generating web statistics.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>
  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      <FORM ACTION=restart.cgi>
      <INPUT TYPE=SUBMIT VALUE="Restart Web Server">
      Click here to restart the web server so your changes take effect.
      <P></FORM>
    </TD>
  </TR>


  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

</TABLE></CENTER><P>

EOF

  if (! system "rpm -q AllCommerce > /dev/null 2>&1") {
    print <<ALLCOMMERCE;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>
      AllCommerce Management
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      Below you can configure your stores.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody">
      <A HREF="opensales/create/"><B>Create a New Store</B></A></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Create a new AllCommerce store.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="opensales/edit/">Edit/Delete a Store</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Edit or delete an existing AllCommerce store.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="opensales/edit/edit_store.cgi">Configure a Store</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Create products, variances, and other store items.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

</TABLE></CENTER><P>
ALLCOMMERCE
  }

  &ryanFooter("/");

