#!/usr/bin/perl

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';
  &ReadParse();


  if (!$in{'DEL'}) { &redirect("/VHost/opensales/edit/"); }

  ### Get the site configuration.
  do "/home/httpd/$in{'DEL'}/conf/site.pm";
  $conf->{'site_config'} = &setsite();



  ### ############################## ###
  ### Make connection to mysql DBMS. ###
  ### ############################## ###
  ### Get the mysql root password.
  open FILE, "/etc/webtool/SystemManager/config";
    while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $dbi_pass = $1; } }
  close FILE;

  ### Make the connection to the DBMS on localhost.
  use DBI;
  $dbh = DBI->connect("DBI:mysql:host=localhost", "root", "$dbi_pass");




  ### ############################################################ ###
  ### Iterate through each site we want to delete and do the deed. ###
  ### ############################################################ ###
  ### Get the apache configuration. ###
  $apache_conf = &get_config();
  @virt = &find_directive_struct("VirtualHost", $apache_conf);

  ### Setup some variables.
  $database = $conf->{'site_config'}->{'site_database'};
  $dbi_user = $conf->{'site_config'}->{'site_dbiuser'};
  $docroot  = "/home/httpd/" . $conf->{'site_config'}->{'fsrelativeroot'};


  ### Go thru each virtual server and store what we want.
  local %store_config;
  foreach $v (@virt) {
    $INDEX = &indexof($v, @$apache_conf);
    $vconf = &get_config()->[$INDEX];
    $tmp = &find_directive_struct("DocumentRoot", $vconf->{'members'});

    if ($tmp->{'words'}->[0] eq $docroot) {
      $VirtIndex    = $INDEX;
      $DocumentRoot = $docroot;
      ($nvh, $Port) = ($v->{'value'} =~ /^(\S+):(\S+)$/);

      $tmp2 = &find_directive_struct("ServerName", $vconf->{'members'});
      $ServerName = $tmp2->{'words'}->[0];
      if (!$Port) { $Port = "80"; }

      $store_config{$Port}->{'index'} = $INDEX;
      $store_config{$Port}->{'root'}  = $docroot;
    }

  }


  ### ####################### ###
  ### Remove the cron script. ###
  ### ####################### ###
    unlink "/etc/cron.ac/$ServerName";


  ### ########################################### ###
  ### Remove the apache entries for both servers. ###
  ### ########################################### ###

    ### Get the config for both servers.
    $vconf_80  = $apache_conf->[$store_config{'80'}->{'index'}];
    $vconf_443 = $apache_conf->[$store_config{'443'}->{'index'}];

    ### We want to start at the top of the 80 directive and end at the bottom 
    ### of the 443 directive.
    $START = $vconf_80->{'line'};
    $END   = $vconf_443->{'eline'};

    ### Splice our changes out then re-write the file.    
    $lref = &read_file_lines($vconf_80->{'file'});
    splice(@$lref, $START, $END - $START + 1);
    &flush_file_lines();

    ###
    # Remove the DocumentRoot.
    #
    # Before we move the DocumentRoot we need to disable LIDS,
    # in case it is protecting the certificate and key.  We also
    # want to reload the config to get rid of the rule, if any.
    ###

    &lids_toggle("off");
      if ($docroot =~ m/^\/home\/httpd\/.*/) { system "rm -rf $docroot"; }
    &lids_reload();
    &lids_toggle("on");



  ### ################## ###
  ### MySQL Maintenance. ###
  ### ################## ###
    ### Drop the database.
    $rv = $dbh->do("DROP DATABASE $database");

    ### Delete the user from mysql.user.
    $rv = $dbh->do("DELETE FROM mysql.user WHERE User = '$dbi_user'");

    ### Delete the user from mysql.db.
    $rv = $dbh->do("DELETE FROM mysql.db WHERE User = '$dbi_user'");

    ### Reload the grant tables.
    $rv = $dbh->do("FLUSH PRIVILEGES");


  ### Disconnect from the database.
  $dbh->disconnect();


  ### Restart the apache daemon.
  system "/etc/init.d/httpd restart";


  ### Go back to the "Edit a Store" page.
  &redirect("/VHost/opensales/edit");

