#!/usr/bin/perl

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';
  &ReadParse();

  $openssl = "/usr/bin/openssl";
  $store   = $in{'store'};

  if (!$in{'commonName'}) {
    &PrintError("Please enter an Authority Name");
  }
  elsif (!$in{'organizationName'}) {
    &PrintError("Please enter an Organization");
  }
  elsif (!$in{'emailAddress'}) {
    &PrintError("Please enter an E-Mail Address");
  }
  elsif (!$in{'localityName'}) {
    &PrintError("Please enter a City");
  }
  elsif (!$in{'stateOrProvinceName'}) {
    &PrintError("Please enter a State or Provence");
  }
  elsif (!$in{'countryName'}) { &PrintError("Please enter a Country Name"); }


  ### Setup our destinations.
  $server_cert = "/home/httpd/$store/ssl/certificate.pem";
  $server_key  = "/home/httpd/$store/ssl/key.pem";

  ### Setup temporary files.
  $cert_temp = &tempname(); 
  $key_temp = &tempname(); 


  ### Open a pipe to ssl and give it our info, and output the cert and key.
  open CA, "| $openssl req -new -x509 -days 365 -nodes -out $cert_temp -keyout $key_temp -config /etc/ssl/openssl.cnf > /dev/null 2>&1";
    print CA "$in{'countryName'}\n";
    print CA "$in{'stateOrProvinceName'}\n";
    print CA "$in{'localityName'}\n";
    print CA "$in{'organizationName'}\n";
    print CA "$in{'organizationalUnitName'}\n";
    print CA "$in{'commonName'}\n";
    print CA "$in{'emailAddress'}\n";
  close CA;


  ### If they exist, move the two files into place.
  if (-r $cert_temp && -r $key_temp) {
    system "mv -f $cert_temp $server_cert";
    system "mv -f $key_temp $server_key";

    chmod 0400, $server_cert, $server_key;
    system "/bin/chown www.www $server_cert, $server_key";
  }

  ### ############################################## ###
  ### Save the directives with our new certificates. ###
  ### ############################################## ###
  if (!$in{'SSLStatus'}) {
    ### ########################################################################
    ### Find the proper virtual server index. ##################################
    ### ########################################################################
    $apache_conf = &get_config();
    @virt = &find_directive_struct("VirtualHost", $apache_conf);

    foreach $v (@virt) {
      $INDEX = &indexof($v, @$apache_conf);
      $vconf = &get_config()->[$INDEX];
      ($nvh, $Port) = ($v->{'value'} =~ /^(\S+):(\S+)$/);
      if (!$Port) { $Port = "80"; }

      $docroot = &find_directive_struct("DocumentRoot", $vconf->{'members'});
      $admin   = &find_directive_struct("ServerAdmin", $vconf->{'members'});
      $name    = &find_directive_struct("ServerName", $vconf->{'members'});

      if ($Port == 443) {
        if ($docroot->{'words'}[0] eq "/home/httpd/$store") {
          $SERVERINDEX_443 = $INDEX;
        }
      }
    }

    ### ########################################################################
    ### Get our virtual config, and update the proper directives. ##############
    ### ########################################################################

    ### Get our config.
    $conf = &get_config();
    $vconf = $conf->[$SERVERINDEX_443];

    ### Read our file lines in.
    $lref = &read_file_lines($vconf->{'file'});

    ### Turn on SSL.
    &save_directive("SSLEngine", [ "on" ], $vconf->{'members'}, $conf);

    ### Update the SSLCertificateFile directive.
    &save_directive("SSLCertificateFile", [ $server_cert ],
                  $vconf->{'members'}, $conf);

    ### Update the SSLCertificateKeyFile directive.
    &save_directive("SSLCertificateKeyFile", [ $server_key ],
                    $vconf->{'members'}, $conf);

    ### Write the file back to disk.
    &flush_file_lines();
  }

  ### We're all done so let's remove our temporary files.
  unlink $cert_temp, $key_temp;

  ### Restart apache.
  system "/etc/init.d/httpd restart";
  sleep 1;


  ### Go back to store index.
  system "/etc/init.d/httpd restart"; sleep 1;
  &redirect("/VHost/opensales/edit/edit_ssl.cgi?store=$store");

