#!/usr/bin/perl

  use DBI;

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';

  &ReadParse();

  if (!$in{'update_store'}) {
    if (!$in{'preview'}) {
      ### Get the info from httpd.conf.

      $apache_conf = &get_config();
      @virt = &find_directive_struct("VirtualHost", $apache_conf);

      foreach $v (@virt) {
        $INDEX = &indexof($v, @$apache_conf);
        $vconf = &get_config()->[$INDEX];
        ($nvh, $Port) = ($v->{'value'} =~ /^(\S+):(\S+)$/);
        if (!$Port) { $Port = "80"; }

        $docroot = &find_directive_struct("DocumentRoot", $vconf->{'members'});
        $admin   = &find_directive_struct("ServerAdmin", $vconf->{'members'});
        $name    = &find_directive_struct("ServerName", $vconf->{'members'});

        if ($Port == 443) {
          if ($docroot->{'words'}[0] eq "/home/httpd/$in{'store'}") {
            $SERVERINDEX_443 = $INDEX;
          }
        }

        if ($Port == 80) {
          if ($docroot->{'words'}[0] eq "/home/httpd/$in{'store'}") {
            $SERVERINDEX_80  = $INDEX;
            $SERVERNAME      = $name->{'words'}[0];
            $SERVERADMIN     = $admin->{'words'}[0], "\n";
          }
        }
      }
    }
    else {
      $SERVERINDEX_80   = $in{'SERVERINDEX_80'};
      $SERVERINDEX_443  = $in{'SERVERINDEX_443'};
      $SERVERNAME       = $in{'SERVERNAME'};
      $SERVERADMIN      = $in{'SERVERADMIN'};
    }

    ### Good ol' header.
    &header("Edit Store", 0);

    print <<EOF01;
<FORM ACTION="edit_webserver.cgi" METHOD="POST">
<INPUT TYPE=HIDDEN NAME=store VALUE=$in{'store'}>
<INPUT TYPE=HIDDEN NAME=SERVERINDEX_80 VALUE=$SERVERINDEX_80>
<INPUT TYPE=HIDDEN NAME=SERVERINDEX_443 VALUE=$SERVERINDEX_443>
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Edit Webserver Configuration</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can change your webserver settings for this store.

    <P><B>Clicking on "Update Store" will make your changes take effect.</B>
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb><TD COLSPAN="2">
        <DIV CLASS="thead"><B>Webserver Configuration</B></DIV>
      </TD></TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Server Name</TD>
        <TD><INPUT TYPE=TEXT NAME=SERVERNAME SIZE=30 VALUE="$SERVERNAME"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Server Admin</TD>
        <TD><INPUT TYPE=TEXT NAME=SERVERADMIN SIZE=30 VALUE="$SERVERADMIN"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT NAME="update_store" VALUE="Update Store">
          <INPUT TYPE=SUBMIT NAME="preview" VALUE="Preview Changes">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER></FORM><P>
EOF01

    ### Good ol' footer.
    &ryanFooter("/VHost/opensales/edit/");
    exit;
  }

  ### ############################ #############################################
  ### We want to update the store. #############################################
  ### ############################ #############################################
  else {

    $SERVERINDEX_80  = $in{'SERVERINDEX_80'};
    $SERVERINDEX_443 = $in{'SERVERINDEX_443'};
    $SERVERNAME      = $in{'SERVERNAME'};
    $SERVERADMIN     = $in{'SERVERADMIN'};

    ### Get the config for both servers.
    $apache_conf = &get_config();
    $vconf_80  = $apache_conf->[$SERVERINDEX_80];
    $vconf_443 = $apache_conf->[$SERVERINDEX_443];

    ### We want to start at the top of the 80 directive and end at the bottom
    ### of the 443 directive.
    $START = $vconf_80->{'line'};
    $END   = $vconf_443->{'eline'};


    $lref = &read_file_lines($vconf_80->{'file'});

    for ($i = $START; $i < $END; $i++) {
      if (@$lref[$i] =~ m/^(\s*)ServerAdmin(\s+)(.*)$/) {
        @$lref[$i] = "$1ServerAdmin$2$SERVERADMIN";
      }

      elsif (@$lref[$i] =~ m/^<VirtualHost (.*)\:(.*)>$/) {
        @$lref[$i] = "<VirtualHost $SERVERNAME:$2>";
      }

      elsif (@$lref[$i] =~ m/^(\s*)ServerName(\s+)(.*)$/) {
        @$lref[$i] = "$1ServerName$2$SERVERNAME";
      }
    }


    ### Re-write the file.
    &flush_file_lines();

    ### ####################################################### ###
    ### Now we need to update machine.conf with our new vaules. ###
    ### ####################################################### ###

    ($mac_host, $mac_dom) = ($SERVERNAME =~ m/^([^\.]+)(.*)$/);

    $machine_file = "/home/httpd/$in{'store'}/conf/machine.conf";

    open TEMP, "$machine_file";
      while (<TEMP>) {
        chomp $_;
        ($key, $value) = split /\s+/, $_;
        $machine_conf{$key} = $value;
      }
    close TEMP;

    $machine_conf{'sitedomain'} = $mac_dom;
    $machine_conf{'sitessldomain'} = $mac_dom;
    $machine_conf{'siteserver'} = $mac_host;
    $machine_conf{'sitesslserver'} = $mac_host;

    &obtain_lock($machine_file);
    open MACHINE, ">$machine_file";

    foreach (keys %machine_conf) {
      print MACHINE "$_  $machine_conf{$_}\n";
    }

    close MACHINE;
    &release_lock($machine_file);


    ### ######################################################## ###
    ### Now we need to update merchant.conf with our new vaules. ###
    ### ######################################################## ###

    $lref = &read_file_lines("/home/httpd/$in{'store'}/conf/merchant_conf");

      foreach (@$lref) {
        if ($_ =~ m/MSW\_DUMMY\_URL\ +\=\ +(.*)$/) {
          $_ =~ s/$1/https:\/\/$SERVERNAME\/html\/eng\/empty.wlt/;
        }
      }

    &flush_file_lines();


    ### ############## ###
    ### Update site.pm ###
    ### ############## ###
    chdir "/home/httpd/$in{'store'}";
      system "crons/update_conf.pl";
      system "chmod 640 conf/site.pm";
      system "chown root.webd conf/site.pm";


    ### Restart the daemon
    system "/etc/init.d/httpd restart";
    sleep 1;

    ### Go back to the daily grind.
    &redirect("/VHost/opensales/edit/");
  }
