#!/usr/bin/perl

  require '../../apache-lib.pl';
  &ReadParse();

  ### Get the setsite() routine to get configuration.  Store in $site.
  $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
  do $site_pm;
  $site = setsite();

  ### Get the FQDN from httpd.conf
  $apache_conf = &get_config();
  @virt = &find_directive_struct("VirtualHost", $apache_conf);

  foreach $v (@virt) {
    $INDEX = &indexof($v, @$apache_conf);
    $vconf = &get_config()->[$INDEX];
    ($nvh, $Port) = ($v->{'value'} =~ /^(\S+):(\S+)$/);
    if (!$Port) { $Port = "80"; }

    $docroot = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $name    = &find_directive_struct("ServerName", $vconf->{'members'});

    if ($Port == 443) {
      if ($docroot->{'words'}[0] eq "/home/httpd/$in{'store'}") {
        $FQDN = $name->{'words'}[0];
      }
    }
  }


  $authority_str    = &hlink("Authority Name", "ssl_authority");
  $email_str        = &hlink("E-Mail Address", "ssl_email");
  $department_str   = &hlink("Department", "ssl_department");
  $organization_str = &hlink("Organization", "ssl_organization");
  $city_str         = &hlink("City", "ssl_city");
  $state_str        = &hlink("State or Province", "ssl_state");
  $country_str      = &hlink("Country", "ssl_country");

  $sslinfo_help   = &hlink("[ Certificate Information ]", "SSLInfo");


  if (!-e "/home/httpd/$in{'store'}/ssl/key.pem") {
    &PrintError("You cannot generate a CSR unless you already have a certificate and key in place.");
  }

  ### Good ol' header.
  &header("Edit Store", 0);

  print <<EOF01;
<FORM ACTION="generate_csr.cgi" METHOD="POST">
<INPUT TYPE=HIDDEN NAME=store VALUE=$in{'store'}>
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Generate a Certificate Signing Request</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can generate a Certificate Signing Request (CSR) for your store.

    <P><B>$sslinfo_help</B>
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb><TD COLSPAN="2">
        <DIV CLASS="thead"><B>Certificate Information</B></DIV>
      </TD></TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$authority_str</B></TD>
        <TD><INPUT NAME=commonName SIZE=30 MAXLENGTH=64 VALUE="$FQDN"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$organization_str</B></TD>
        <TD><INPUT NAME=organizationName SIZE=30 VALUE="$site->{'sitename'}"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$department_str</B></TD>
        <TD><INPUT NAME=organizationalUnitName SIZE=30></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$email_str</B></TD>
        <TD><INPUT NAME=emailAddress SIZE=30 MAXLENGTH=40></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$city_str</B></TD>
        <TD><INPUT NAME=localityName SIZE=30></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$state_str</B></TD>
        <TD><INPUT NAME=stateOrProvinceName SIZE=15></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$country_str</B></TD>
        <TD><INPUT NAME=countryName SIZE=3 MAXLENGTH=2></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT VALUE="Generate CSR">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER></FORM><P>
EOF01

  ### Good ol' footer.
  &ryanFooter("/VHost/opensales/edit/");

